Subject: Re: bug#631: the M- notation suggestion

From: "Lennart Borgman (gmail)" <[email-masked]>
Date: Mon, 04 Aug 2008 13:38:10 +0200

Joe Wells wrote:
> xah lee <[email-masked]> writes:
> 
>> The proposed change doesn't actually effect elisp code. It is primarly
>> esthetic in nature.
> 
> This is not true.  There are many places in the Emacs Lisp code which
> recognize the M- and C- notation.

Thanks Joe for this list.

I am thinking about the possibility to just change what is shown in 
menus and help texts (see my earlier reply to Xah's bug report). Such a 
change would of course be optional, but might help new users.

With such a change there would of course be a steop for new users when 
they are just frustrated because they do not understand how to do key 
bindings, "why does not (kbd "Alt-<down>") work?", etc.

And the manual would probably better still use the current notation 
(with a note about the new notation) because it is static and is read on 
different platform. So everything would not be better, but the initial 
treshold would probably be lower.

Can you see any technical trouble with the changes I am suggesting could 
be done?

> First, there is the read syntax (I'm using Emacs 22.1):
> 
>   ?\M-A ⇒ 134217793
>   ?\M-\C-b ⇒ 134217730
> 
>   "\M-A" ⇒ "\301" (yes, this is a bit different behavior for M-A)
> 
> Then, there is the convention of making symbol names with prefixes for
> use in key bindings:
> 
>   M-f3
>   M-mouse-1
>   M-drag-mouse-2
>   M-double-mouse-2
> 
> Then, there is the lovely kbd macro for use in key bindings:
> 
>   (kbd "C-M-<down>") ⇒ [C-M-down]
> 
> Then, there is the use of the M- and C- notation by edit-kbd-macro.
> 
> Then, there are the key-description, single-key-description, and
> read-kbd-macro functions:
> 
>   (key-description [?\M-3 delete]) ⇒ "M-3 <delete>"
> 
> There is also the text-char-description function.
>